package board;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Point;
import java.util.*;

public class Puzzle {

	ArrayList pieces;
	Image image;
	int width;
	int height;

	void setImage(String filename){
		image = loadImage(filename);
		
		width = image.getWidth(null);
		height = image.getHeight(null);
		
		int unit_size = 200;
		int nx = width/unit_size +1;
		int ny = height/unit_size +1;
		int wx = width / nx;
		int wy = height / ny;
	
		pieces = new ArrayList();
		
		for(int x=0; x<nx; x++)
			for(int y=0; y<ny; y++){
				Piece piece = new Piece(this, 200+x*wx, 100+y*wy, wx, wy);
				pieces.add(piece);
				Graphics g2 = piece.image.getGraphics();
				g2.drawImage(image, 0, 0, wx, wy, wx*x, wy*y, wx*x+wx, wy*y+wy, null);
				g2.dispose();
			}
		shuffle();
	}
	
	void shuffle(){
		for(int i=0; i<pieces.size(); i++){
			Piece piece = (Piece)pieces.get(i);
			piece.position.x = 200 + (int)(600*Math.random());
			piece.position.y = 100 + (int)(400*Math.random());
			piece.angle = 90* ((int)(4*Math.random()));
			piece.snap();
		}
	}
	void draw(Graphics g){
		g.drawImage(image, 0,0,width/4, height/4, null);
		
		draw_pieces(g);
	}
	void draw_pieces(Graphics g){
		for(int i=0; i<pieces.size(); i++){
			Piece piece = (Piece) pieces.get(i);
			piece.draw(g);
		}
	}	
	Piece pick_piece(Point p){
		Piece picked_piece = null;
		for(int i=pieces.size()-1; i>=0; i--){
			Piece piece = (Piece) pieces.get(i);
			if (piece.picked(p)){
				picked_piece = piece;
				break;
			}
		}
		return picked_piece;
	}	

	
	
	
	
	static Image loadImage(String filename){
		Image new_image = MainPanel.mainPanel.getToolkit().getImage( filename );
		if (new_image != null) {
			MediaTracker mt = new MediaTracker(MainPanel.mainPanel);
			try	{
				mt.addImage(new_image, 0);
				mt.waitForAll();
			}	
			catch (InterruptedException ie) {}
		}
		return new_image;
	}
}
